/* This file is part of the Cyclone Library.
   Copyright (C) 2001 Greg Morrisett

   This library is free software; you can redistribute it and/or it
   under the terms of the GNU Lesser General Public License as
   published by the Free Software Foundation; either version 2.1 of
   the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with this library; see the file COPYING.LIB.  If not,
   write to the Free Software Foundation, Inc., 59 Temple Place, Suite
   330, Boston, MA 02111-1307 USA. */

#ifndef _SYS_TIME_H
#define _SYS_TIME_H

#include <sys/ctypes.h> // for time_t

namespace Std {
struct timeval {
  time_t tv_sec;
  long tv_usec;
};

struct timezone {
  int tz_minuteswest;
  int tz_dsttime;
};

extern "C" int gettimeofday(struct timeval @__p,struct timezone *__z);

struct itimerval {
  struct timeval it_interval;
  struct timeval it_value;
};

#define ITIMER_VIRTUAL 1 
#define ITIMER_REAL 0 
#define ITIMER_PROF 2 

  extern "C" int getitimer(int, struct itimerval @);
  extern "C" int setitimer(int, const struct itimerval @, struct itimerval *);

}

#ifdef __CYGWIN__
#include <sys/cselect.h>
#endif
#ifdef __linux__
#include <sys/cselect.h>
#endif

#endif
